using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PostProcessing
{
    public class Spring1D
    {
        private float velocity;

        public float Value;
        public float TargetValue;
        public float Stiffness;
        public float Damping;
        public float Mass;

        public Spring1D(float mass, float damping, float stiffness, float initialValue)
        {
            Mass = mass;
            Damping = damping;
            Stiffness = stiffness;
            velocity = 0;
            Value = TargetValue = initialValue;
        }

        public Spring1D(float mass, float damping, float stiffness)
            : this(mass, damping, stiffness, 0)
        {
        }

        public Spring1D(float initialValue)
            : this(1, 10, 100, initialValue)
        { 
        }

        public void Update(float elapsedSeconds)
        {
            float stretch = Value - TargetValue;
            float force = -Stiffness * stretch - Damping * velocity;

            // Apply acceleration
            float acceleration = force / Mass;
            velocity += acceleration * elapsedSeconds;
            Value += velocity * elapsedSeconds;
        }
    }
}
